#include "FStrList.H"
#include <unistd.h>

FStrList::FStrList(const string &fname):
		StrList() {
	string
		tmp;
	char
		buf[1024];

	_filename=fname;
	if ((_fp=fopen(_filename.c_str(),"r+"))!=NULL) {
		while (fgets(buf, sizeof(buf), _fp)) {
			buf[strlen(buf)-1]=0;
			tmp=buf;
			StrList::add(tmp);
		}
	}
	else
		_fp=fopen(_filename.c_str(),"w");
	setbuf(_fp,NULL);
}

FStrList::~FStrList() {
	fclose(_fp);
}

FStrList &FStrList::operator=(const StrList &sl) {
    StrList::clear();
	rewind(_fp);
	// HACK alert !!!
	truncate(_filename.c_str(),0);
	add(sl);
    return (*this);
}

int FStrList::add(const string &str) {
	fprintf(_fp,"%s\n",str.c_str());
	return (StrList::add(str));
}

int FStrList::add(const StrList &strlist) {
    unsigned int i;
    for (i=0; i < strlist.size(); i++)
        add(strlist[i]);
    return i;
}

int FStrList::remove(const string &str) {
	StrList::remove(str);
	rewrite();	
	return 0;
}

int FStrList::remove(unsigned int idx) {
	StrList::remove(idx);
	rewrite();	
	return 0;
}

void FStrList::rewrite() {
	rewind(_fp);
	// HACK alert !!!
	truncate(_filename.c_str(),0);
	for (unsigned int i=0; i < size(); i++) {
		fprintf(_fp,"%s\n",StrList::operator[](i).c_str());
	}
}
